# idTweaks

![Lint Badge](https://img.shields.io/endpoint?url=https://gist.githubusercontent.com/Industrial/8375a84ebf88587fbc924582831f7678/raw/lint.json)
![Test Badge](https://img.shields.io/endpoint?url=https://gist.githubusercontent.com/Industrial/8375a84ebf88587fbc924582831f7678/raw/test.json)
![Deploy Badge](https://img.shields.io/endpoint?url=https://gist.githubusercontent.com/Industrial/8375a84ebf88587fbc924582831f7678/raw/deploy.json)

World of Warcraft AddOn. Automates many things with UI Options for each. Type
`/idt` or `/idtweaks` to start configuring.

Do you have an idea or suggestion? Leave a comment here or open a ticket on
github (https://github.com/Industrial/idTweaks).

## Modules

### Automation
- All versions (BC & Retail)
  - Accept
    - Hearthstone Bind
    - PVP Release
    - Resurrection
    - Summon
  - Vendor
    - Sell Grey Items
    - Repair
- Retail
  - Summon Favorite Minipet
- BC
  - Dismount.

### BlizzardUI
- All versions (BC & Retail)
  - Hide
    - Buffs
    - Castingbar
    - Error messages

### Chat
- All versions (BC & Retail)
  - Slash Commands (/rl, /lfg)
    - /rl for Reload UI
    - /lfg for Looking For Group
  - Messages
    - Loot
    - XP
    - Rep
    - Achievements
    - Skill
    - System

### Mail
- All versions (BC & Retail)
  - Send mail when 12th item and sender are filled.

### Minimap
- All versions (BC & Retail)
  - Zoom with Mousewheel
  - Hide
    - Area Text
    - Calendar Button
    - North Tag
    - Time Display
    - World Map Button
    - Zoom Buttons
  - Shape
    - Square
- BC
  - Hide
    - Close Button

### Questing
- All versions (BC & Retail)
  - Accept Quests
  - Complete Quests (No reward)
  - Complete Gossip (1 option available)

### Tooltips
- All versions (BC & Retail)
  - Anchor
    - Top Left
    - Top Right
    - Cursor Center
    - Cursor Left
    - Cursor Right
    - Bottom Left
    - Bottom Right
  - Offset
    - X
    - Y

## Development
Currently, I run the game on Windows. I have made the development environment reproducible with Docker (Compose) so you can run it too. All you need is Linux or play on a Mac.

### 1. Installation
1. Install VSCode.
1. Install WSL2.
1. Install Ubuntu for WSL2. It comes with Docker and Docker compose.
1. Start an Ubuntu terminal and run these commands:
   ```bash
    # Create a directory for coding projects if it doesn't exist yet.
    $ mkdir -p ~/Code

    # Clone idTweaks into it.
    $ git clone git@github.com:Industrial/idTweaks.git ~/Code/idTweaks

    # Enter the directory.
    $ cd ~/Code/idTweaks

    # Start VSCode
    $ code .

    # Start the Docker Container.
    $ docker-compose up
   ```

### 2. Making Changes
Every time you change a MoonScript in the src directory a few programs will run:

1. `moonc` the MoonScript compiler will lint your MoonScript files. This will report problems with the source code.
1. `moonc` the MoonScript compiler will compile all files from the `src` directory to the `build` directory.
1. `luacheck` will report things that should not happen in the wow environment like accessing unknown globals.
1. `busted` will run tests from the test directory.
1. `luacov` will show howmuch % of the code has been tested.

### 3. World of Warcraft directory
The source code will still be inside Linux and not available to the game. You need to copy the whole directory from the `\\wsl$\Ubuntu\home\YOURUSER\Code\idTweaks` to the `SOMEWHERE/World of Warcraft/_retail_/Interface/Addons` directory yourself. If you have a good solution for this, please let me know!

I'm using "Git for Windows with MSYS" and run the command
```bash
rm -rf "/c/Games/World of Warcraft/_retail_/Interface/AddOns/idTweaks/*"; cp -R //wsl$/Ubuntu/home/tom/Code/idTweaks/* "/c/Games/World of Warcraft/_retail_/Interface/AddOns/idTweaks";
```
